               .MODEL  large, c

               .DATA

_J_HasDoneInit  Db      0
_J_ProtModeFlg  Db      0
_J_IsNovellFlg  Dw      0

               .CODE

                Extrn   _ret:FAR
                Extrn   _retni:FAR
                Extrn   _retl:FAR
                Extrn   C DosRealIntr:FAR
                Extrn   PASCAL DosAllocRealSeg:FAR
                Extrn   PASCAL DosFreeRealSeg:FAR
                Extrn   PASCAL DosGetMachineMode:FAR

;Ŀ
; IsNovell()                                                                
;Ĵ
; Return TRUE(1) if Novell, else return FALSE(0)                            
;
_J_IsNovell     PROC    FAR C
                Push    Ds              ;Save reg
                Mov     Ax,@Data        ;Ds->Data
                Mov     Ds,Ax           ;
                Assume  Ds:@Data        ;
                Cmp     [_J_HasDoneInit],0;If init not done
                Jz      J_IsNovell0     ;Then do it now
                Mov     Ax,[_J_IsNovellFlg]
                Pop     Ds              ;Get preset value
                Or      Ah,Al           ;
                Ret                     ;Done
;
J_IsNovell0:    Mov     [_J_HasDoneInit],1;Set init done
                Push    Ds              ;
                Mov     Bx,Offset _J_ProtModeFlg
                Push    Bx              ;
                Call    DosGetMachineMode
                Mov     Ax,0C601h       ;Set 'LockMode' to 1
                Call    _J_Int021h      ;
                Push    Ax              ;Save entry mode
                Mov     Ax,0C602h       ;Get current 'LockMode'
                Call    _J_Int021h      ;
                Cmp     Al,001h         ;If not mode 1 returned
                Jnz     J_IsNovell1     ;Then not novell
                Pop     Ax              ;Restore entry mode
                Mov     Ah,0C6h         ;
                Call    _J_Int021h      ;
                Mov     Ax,1            ;Novell
                Mov     [_J_IsNovellFlg],Ax
                Pop     Ds              ;
                Or      Ah,Al           ;
                Ret                     ;Done
;
J_IsNovell1:    Pop     Ax              ;Clear the stack
                Xor     Ax,Ax           ;Not novell
                Mov     [_J_IsNovellFlg],Ax
                Pop     Ds              ;
                Or      Ah,Al           ;
                Ret                     ;Done
_J_IsNovell     Endp

;Ŀ
; IsProtMode()                                                              
;Ĵ
; Return the protectedmode flag                                             
;
_J_IsProtMode   PROC    FAR C
                Call    _J_IsNovell     ;Test if Novell
                Push    Ds              ;Save reg
                Mov     Ax,@Data        ;Ds->Data
                Mov     Ds,Ax           ;
                Assume  Ds:@Data        ;
                Mov     Al,[_J_ProtModeFlg]
                Mov     Ah,0            ;
                Pop     Ds              ;Get preset value
                Or      Ah,Al           ;
                Ret                     ;Done
_J_IsProtMode   Endp

;Ŀ
; ConnectionNumber()                                                        
;Ĵ
; Return the Novell connection number                                       
;
_J_ConNumb      PROC    FAR C
                Call    _J_IsNovell     ;Test if Novell
                Jz      J_ConNumb1      ;Then return '00'
                Mov     Ax,0DC00h       ;Get station number
                Call    _J_Int021h      ;
                Mov     Ax,Cx           ;Get result in Ax
                Ret                     ;Done
;
J_ConNumb1:     Mov     Ax,03030h       ;Not Novell
                Ret                     ;Done
_J_ConNumb      Endp

;Ŀ
; GetDefaultDriveNumber()                                                   
;Ĵ
; Return the default drive number ( 0='A:' 1='B:' etc. )                    
;
_J_CurDrive     PROC    FAR C
                Mov     Ah,019h         ;Get drive
                Int     021h            ;
                Xor     Ah,Ah           ;Result in Al
                Ret                     ;Done
_J_CurDrive     Endp

;Ŀ
; TrueName()                                                                
;Ĵ
; Get the TRUE-name of a file                                               
;
_J_TrueName     PROC    FAR C, Src:FAR PTR BYTE, Dst:FAR PTR BYTE
                Push    Di
                Push    Si
                Push    Ds
                Push    Es
                Les     Di,Dst
                Lds     Si,Src
                Mov     Ah,060h
                Int     021h
                Mov     Ax,0            ;If error, Then return 1
                Adc     Ax,0
                Pop     Es
                Pop     Ds
                Pop     Si
                Pop     Di
                Ret                     ;Done
_J_TrueName     Endp

;Ŀ
; SemOpen()                                                                 
;Ĵ
; Open a semaphore                                                          
;
_J_SemOpen      PROC    FAR; C, Sem:FAR PTR BYTE, Val:WORD, BufLen:WORD
                Call    _J_IsNovell
                Jnz     J_SemOpenNov
                Mov     Ax,1
                Mov     Dx,0
                Ret
;
J_SemOpenNov:   Push    Ds
                Push    Ax
                Mov     Ax,@Data        ;Ds->Data
                Mov     Ds,Ax           ;
                Assume  Ds:@Data        ;
                Cmp     [_J_ProtModeFlg],0
                Pop     Ax
                Pop     Ds
                Jz      J_SemOpenReal
                Pushf
                Push    Si
                Push    Di
                Push    Es
                Push    Ds
                Push    Bp
                Mov     Bp,Sp
                Sub     Sp,4            ;Space for 'Para' and 'Sel'
                Mov     Ax,[Bp+22]      ;Buffer length
                Cwd                     ;
                Push    Dx              ;
                Push    Ax              ;
                Lea     Ax,[Bp-4]       ;Pointer to 'Para'
                Push    Ss              ;
                Push    Ax              ;
                Lea     Ax,[Bp-2]       ;Pointer to 'Sel'
                Push    Ss              ;
                Push    Ax              ;
                Call    DosAllocRealSeg ;Allocate buffer space
                Or      Ah,Al           ;If error
                Jnz     J_SemOpenErr    ;Then done
                Lds     Si,[Bp+16]      ;Ds:Si -> Sem
                Mov     Es,[Bp-2]       ;Es:Di -> Sel:0
                Mov     Di,0            ;
                Mov     Cx,[Bp+22]      ;Cx = Count
                Cld                     ;Move by incrementing
                Rep     MovSb           ;Move Ds:Si++ -> Es:Di++ while Cx--
                Pushf                   ;Start creating 'REGS16'-structure
                Push    Cs              ;
                Call    Near Ptr J_SemOpen0;Push Ip
J_SemOpen0:     Mov     Ax,0C500h       ;Ax = Function
                Push    Ax              ;
                Push    [Bp+20]         ;Cx = nValue
                Mov     Dx,0            ;Ds:Dx -> Para:0
                Push    Dx              ;
                Push    Bx              ;
                Push    Sp              ;
                Push    Bp              ;
                Push    Si              ;
                Push    Di              ;
                Push    [Bp-4]          ;Ds:Dx -> Para:0
                Push    Es              ;Last of the 'REGS16'-structure
                Mov     Bx,Sp           ;Save offset to 'REGS16'-structure
                Sub     Ax,Ax           ;0L
                Push    Ax              ;
                Push    Ax              ;
                Push    Ax              ;0 Number of extra words on stack
                Push    Ss              ;Far Ptr 'REGS16'-structure
                Push    Bx              ;
                Mov     Ax,00021h       ;Int 021h
                Push    Ax              ;
                Call    DosRealIntr     ;
                Or      Ah,Al           ;If error
                Jnz     J_SemIntrErr    ;Then done
                Add     Sp,26           ;Clear the stack
                Push    [Bp-2]          ;Value of 'Sel'
                Call    DosFreeRealSeg  ;Release allocated buffer
                Or      Ah,Al           ;If error
                Jnz     J_SemOpenErr    ;Then done
                Pop     Dx              ;Get result, Cx:Dx = Semaphore handle
                Pop     Cx              ;
                Pop     Ax              ;Get result, Al = Status
                Cmp     Al,0            ;If error
                Jnz     J_SemOpenErr    ;Then done
                Mov     Sp,Bp
                Pop     Bp
                Pop     Ds
                Pop     Es
                Pop     Di
                Pop     Si
                Popf
                Mov     Ax,Cx
                Ret
;
J_SemIntrErr:   Push    [Bp-2]          ;Value of 'Sel'
                Call    DosFreeRealSeg  ;Release allocated buffer
J_SemOpenErr:   Mov     Sp,Bp
                Pop     Bp
                Pop     Ds
                Pop     Es
                Pop     Di
                Pop     Si
                Popf
                Xor     Ax,Ax
                Xor     Dx,Dx
                Ret
;
J_SemOpenReal:  Push    Ds
                Push    Bp
                Mov     Bp,Sp
                Lds     Dx,[Bp+8]
                Mov     Ax,0C500h
                Mov     Cx,[Bp+12]
                Pop     Bp
                Call    _J_Int021h
                Pop     Ds
                Cmp     Al,0
                Mov     Ax,Cx
                Jz      J_SemOpenReal1
                Xor     Ax,Ax
                Xor     Dx,Dx
J_SemOpenReal1: Ret
_J_SemOpen      Endp

;Ŀ
; SemVal()                                                                  
;Ĵ
; Val of a semaphore                                                        
;
_J_SemVal       PROC    FAR C, HandleL:WORD, HandleH:WORD
                Call    _J_IsNovell
                Mov     Cx,0
                Jz      J_SemVal1
                Mov     Cx,HandleL
                Mov     Dx,HandleH
                Mov     Ax,0C501h
                Call    _J_Int021h
                Cmp     Al,0
                Jz      J_SemVal1
                Call    _ret
                Ret
;
J_SemVal1:      Push    Cx
                Call    _retni
                Add     Sp,2
                Ret
_J_SemVal       Endp

;Ŀ
; SemOpc()                                                                  
;Ĵ
; Open count of a semaphore                                                 
;
_J_SemOpc       PROC    FAR C, HandleL:WORD, HandleH:WORD
                Call    _J_IsNovell
                Mov     Dl,0
                Jz      J_SemOpc1
                Mov     Cx,HandleL
                Mov     Dx,HandleH
                Mov     Ax,0C501h
                Call    _J_Int021h
                Cmp     Al,0
                Jz      J_SemOpc1
                Call    _ret
                Ret
;
J_SemOpc1:      Mov     Al,Dl
                Cbw
                Push    Ax
                Call    _retni
                Add     Sp,2
                Ret
_J_SemOpc       Endp

;Ŀ
; SemFn()                                                                   
;Ĵ
; Semaphore function support                                                
;
_J_SemFn        PROC    FAR C, HandleL:WORD, HandleH:WORD, Opp:WORD, Time:WORD
                Call    _J_IsNovell
                Mov     Ax,1
                Jz      J_SemFn1
                Mov     Cx,HandleL
                Mov     Dx,HandleH
                Push    Bp
                Mov     Ax,Opp
                Mov     Bp,Time
                Call    _J_Int021h
                Pop     Bp
                Cmp     Al,0
                Mov     Ax,0
                Jnz     J_SemFn1
                Inc     Ax
J_SemFn1:       Push    Ax
                Call    _retl
                Add     Sp,2
                Ret
_J_SemFn        Endp

;Ŀ
; Int21h()                                                                  
;Ĵ
; Execute a 'Int21h' dos function                                           
;
_J_Int021h      PROC    FAR C
                Push    Ds
                Push    Ax
                Mov     Ax,@Data        ;Ds->Data
                Mov     Ds,Ax           ;
                Assume  Ds:@Data        ;
                Cmp     [_J_ProtModeFlg],0
                Pop     Ax
                Pop     Ds
                Jz      J_Int021hReal
                Pushf                   ;Start creating 'REGS16'-structure
                Push    Cs              ;
                Call    Near Ptr J_Int021h;Push Ip
J_Int021h:      Push    Ax              ;
                Push    Cx              ;
                Push    Dx              ;
                Push    Bx              ;
                Push    Sp              ;
                Push    Bp              ;
                Push    Si              ;
                Push    Di              ;
                Push    Ds              ;
                Push    Es              ;Last of the 'REGS16'-structure
                Mov     Bx,Sp           ;Save offset to 'REGS16'-structure
                Sub     Ax,Ax           ;0L
                Push    Ax              ;
                Push    Ax              ;
                Push    Ax              ;0 Number of extra words on stack
                Push    Ss              ;Far Ptr 'Regs'
                Push    Bx              ;
                Mov     Ax,00021h       ;Int 021h
                Push    Ax              ;
                Call    DosRealIntr     ;
                Add     Sp,12           ;Clear the stack
                Pop     Es              ;
                Pop     Ds              ;
                Pop     Di              ;
                Pop     Si              ;
                Pop     Bp              ;
                Add     Sp,2            ;Sp
                Pop     Bx              ;
                Pop     Dx              ;
                Pop     Cx              ;
                Pop     Ax              ;
                Add     Sp,4            ;Ip,Cs
                Popf                    ;
                Ret                     ;Done
;
J_Int021hReal:  Int     021h
                Ret
_J_Int021h      Endp

                End
