//Compile:/C

#Include "INIOBJ.CH"
#Include "ERROR.CH"

Static ComlProgSave, ComlPathSave, ComlDrivSave

// ͻ
//  Setup the 'Coml...' statics                                             
// ͼ
Init Procedure InitSupport()
Local TmpStr,Y,X
   TmpStr:=Program()
   ComlProgSave:=If((Y:=At(".",TmpStr))>0  AND;
                    (X:=RAt("\",TmpStr))>1 AND;
                    SubStr(TmpStr,2,1)==":"   ;
                   ,SubStr(TmpStr,X+1,Y-X-1)  ;
                   ,""                        )
   ComlPathSave:=If((X:=RAt("\",TmpStr))>1 AND;
                    SubStr(TmpStr,2,1)==":"   ;
                   ,SubStr(TmpStr,3,X-2)      ;
                   ,""                        )
   ComlDrivSave:=If(SubStr(TmpStr,2,1)==":",Left(TmpStr,1),"")
Return

// ͻ
//  MakeErrorNew() // Create a specialized error-object                     
// Ķ
//  InpSubSysChar    Set by using 'ForceError'                           
//     GenCodNumeric Select from 'ERR_XXXX'                              
//     P1..PnAny     Parameters depending on the error-type              
// Ķ
//  RetErrObjObject  The error-object created                            
// ͼ
Function MakeErrorNew(SubSys,GenCode,P1,P2,P3)
Local ErrObj:=ErrorNew()
   ErrObj:CanDefault:=FALSE
   ErrObj:CanRetry:=FALSE
   ErrObj:CanSubstitute:=FALSE
   ErrObj:Severity:=ES_ERROR
   ErrObj:GenCode:=GenCode
   ErrObj:SubSystem:=SubSys
   Do Case
   Case GenCode==EG_OPEN  OR GenCode==EG_CREATE OR;   // P1=Handle, P2=FileName
        GenCode==EG_CLOSE OR GenCode==EG_READ   OR;
        GenCode==EG_WRITE
      ErrObj:FileName:=P2
      ErrObj:OsCode:=If(FError()<>0,FError(),DosError())
      ErrObj:Description:="File error"
      If P1<>NIL Then FClose(P1)
// Case GenCode==EG_ECONNECT                   // P1=ErrorNummer from EConnect
//    ErrObj:SubCode:=P1
//    ErrObj:Description:="E-Connect fout"
// Case GenCode==EG_EX5SYS          // P1=FileObject, P2=Routine, P3=ErrorCode
//    ErrObj:SubCode:=P3
//    ErrObj:Description:="Exact5 DBF: "+P1:DbfFile+";";
//                       +P1:DbfDesc+";Tijdens: "+P2+"()"
//    ErrObj:Cargo:=P1
// Case GenCode==EG_DBFSYS          // P1=FileObject, P2=Routine, P3=ErrorCode
//    ErrObj:SubCode:=P3
//    ErrObj:Description:="Clipper DBF: "+P1:DbfFile+";";
//                       +P1:DbfDesc+";Tijdens: "+P2+"()"
//    ErrObj:Cargo:=P1
// Case GenCode==EG_ARRSYS          // P1=FileObject, P2=Routine, P3=ErrorCode
//    ErrObj:SubCode:=P3
//    ErrObj:Description:="Array DBF: "+P1:DbfFile+";";
//                       +P1:DbfDesc+";Tijdens: "+P2+"()"
//    ErrObj:Cargo:=P1
   Otherwise
      ErrObj:GenCode:=500           // Note: 500 == EG_UNKNOWN
      ErrObj:Description:="Unknown error"
   EndCase
   ErrObj:Description+=";Routine: "+MethodName(1)
Return ErrObj

// ͻ
//  Return the driveletter from where the program was loaded                
//  Full program path := ComlDrive()+":"+ComlPath()+ComlProgram()+".EXE"    
// Ķ
//  Ret      Char    Driveletter ( Eg. 'A'..'Z' )                        
// ͼ
Function ComlDrive()
Return ComlDrivSave

// ͻ
//  Return the path from where the program was loaded                       
//  Full program path := ComlDrive()+":"+ComlPath()+ComlProgram()+".EXE"    
// Ķ
//  Ret      Char    Path ( Eg. '\'..'\Path\...\' )                      
//                   This string always ends with an '\'                 
// ͼ
Function ComlPath()
Return ComlPathSave

// ͻ
//  Return the name of the program that was loaded                          
//  Full program path := ComlDrive()+":"+ComlPath()+ComlProgram()+".EXE"    
// Ķ
//  Ret      Char    Name of the program ( Can be renamed by the user )  
//                   The extention of the filename is not included       
// ͼ
Function ComlProgram()
Return ComlProgSave

